image: docker:18.09.6

variables:
  # When using dind service we need to instruct docker, to talk with the
  # daemon started inside of the service. The daemon is available with
  # a network connection instead of the default /var/run/docker.sock socket.
  #
  # The 'docker' hostname is the alias of the service container as described at
  # https://docs.gitlab.com/ee/ci/docker/using_docker_images.html#accessing-the-services
  #
  # Note that if you're using the Kubernetes executor, the variable should be set to
  # tcp://localhost:2375/ because of how the Kubernetes executor connects services
  # to the job container
  # DOCKER_HOST: tcp://localhost:2375/
  #
  # For non-Kubernetes executors, we use tcp://docker:2375/
  DOCKER_HOST: tcp://docker:2375/
    # When using dind, it's wise to use the overlayfs driver for
    # improved performance.
  DOCKER_DRIVER: overlay2
  CONTAINER_IMAGE: registry.gitlab.com/hipsters-and-hackers/doggo-man/dog-haus
  CONTAINER_TST_IMAGE: $CONTAINER_IMAGE:$CI_BUILD_REF_NAME
  CONTAINER_STG_IMAGE: $CONTAINER_IMAGE:staging
  CONTAINER_PRD_IMAGE: $CONTAINER_IMAGE:latest
  PYTHON_VERSION: 3.7.3-alpine

stages:
  - build
  - coverage
  - test
  - release
  - deploy

build_image:
  services:
    - docker:dind
  stage: build
  script:
    - docker login -u $REGISTRY_USERNAME -p $REGISTRY_PASSWORD registry.gitlab.com
    - docker build -t $CONTAINER_TST_IMAGE --build-arg PYTHON_VERSION=$PYTHON_VERSION .
    - docker push $CONTAINER_TST_IMAGE
    #- docker run --entrypoint '/usr/local/bin/python' nikkorenz/dog-haus -m unittest discover -s /src/tests/unit/

# Unit tests and code coverage
code_quality:
  stage: build
  image: python:$PYTHON_VERSION
  script:
    - pip install pytest-cov flask
    - cd src/
    - pytest -v --cov=modules --cov-report=html --cov-fail-under=70 tests/unit/
  coverage: '/Total.*?(\d{1,3}.\d+%)/i'
  artifacts:
    paths:
      - src/htmlcov/

test:
  stage: test
  services:
    - docker:dind
  script:
    - docker login -u $REGISTRY_USERNAME -p $REGISTRY_PASSWORD registry.gitlab.com
    - docker pull $CONTAINER_TST_IMAGE
    - docker run --name dog_haus_test -p 5000:5000 -d $CONTAINER_TST_IMAGE
    - sleep 30 #sleep to make sure the container is up before running tests
    - apk update && apk add python3 py-pip
    - pip3 install requests
    - python3 src/tests/integration/test_endpoints.py -v
    #- docker exec -t dog_haus_test python tests/integration/test_endpoints.py -v

release_stg:
  stage: release
  services:
    - docker:dind
  script:
    - docker login -u $REGISTRY_USERNAME -p $REGISTRY_PASSWORD registry.gitlab.com
    - docker pull $CONTAINER_TST_IMAGE
    - docker tag $CONTAINER_TST_IMAGE $CONTAINER_STG_IMAGE
    - docker push $CONTAINER_STG_IMAGE
  only:
    - master

pages:
  stage: deploy
  dependencies:
    - code_quality
  script:
    - mv src/htmlcov/ public/
  artifacts:
    paths:
      - public
    expire_in: 30 days
  only:
    - master
